/*
|---------------------------------------------|
| simple mouse example for the ti-83cc        |
| written by Jeremy Scoggins                  |
|                                             |
| Jeremy Scoggins tinkering with the          |
| putsprite routine                           |
|---------------------------------------------|
*/
#include <ti.h>
#include <fastcopy.h>
#include <line.c>
#include <box.c>

/* Program Name */
#name "Mouse 83"

char mouse_x, mouse_y, key;
char mouse_x2, mouse_y2;

main()
{
 clrlcd;
 indicatoroff;
 clearbuffer;

 mouse_x=10;
 mouse_y=10;
 mouse_x2=10;
 mouse_y2=10;

 line(41,21,41,31,PT_ON);
 line(21,31,41,31,PT_ON);
 box(20,20,40,30,PT_ON);
 PutMouse(mouse_x, mouse_y);
 FastCopy();

 while(!GetMouseMove())
 {
  PutMouse(mouse_x2,mouse_y2);
  PutMouse(mouse_x, mouse_y);
  FastCopy();
  mouse_x2=mouse_x;
  mouse_y2=mouse_y;
 }
}

GetMouseMove()
{
 key = getkey();

 if(key==kUp)
  mouse_y-=2;
 if(key==kDown)
  mouse_y+=2;
 if(key==kLeft)
  mouse_x-=2;
 if(key==kRight)
  mouse_x+=2;
 if(key==kClear)
  return(1);
}

PutMouse(x,y) char x,y; {
 #asm
	ld	hl,4
	add	hl,sp
	ld	a,(hl)

	ld	hl,2
	add	hl,sp
	ld	e,(hl)

	ld	bc,mouse


        push    bc              ; Save sprite address

 ;====   Calculate the address in graphbuf   ====

        ld      hl,0            ; Do y*12
        ld      d,0
        add     hl,de
        add     hl,de
        add     hl,de

        add     hl,hl
        add     hl,hl

        ld      d,0             ; Do x/8
        ld      e,a
        srl     e
        srl     e
        srl     e
        add     hl,de

        ld      de,PLOTSSCREEN
        add     hl,de           ; Add address to graphbuf

        ld      b,00000111b     ; Get the remainder of x/8
        and     b
        cp      0               ; Is this sprite aligned to 8*n,y?
        jp      z,ALIGN


 ;====   Non aligned sprite blit starts here   ====

        pop     ix              ; ix->sprite
        ld      d,a             ; d=how many bits to shift each line

        ld      e,8             ; Line loop
LILOP:  ld      b,(ix+0)        ; Get sprite data

        ld      c,0             ; Shift loop
        push    de
SHLOP:  srl     b
        rr      c
        dec     d
        jp      nz,SHLOP
        pop     de

        ld      a,b             ; Write line to graphbuf
        xor     (hl)
        ld      (hl),a

        inc     hl
        ld      a,c
        xor     (hl)
        ld      (hl),a

        ld      bc,11           ; Calculate next line address
        add     hl,bc
        inc     ix              ; Inc spritepointer

        dec     e
        jp      nz,LILOP        ; Next line

        jp      DONE1


 ;====   Aligned sprite blit starts here   ====

ALIGN:                          ; Blit an aligned sprite to graphbuf
        pop     de              ; de->sprite

        ld      b,8
ALOP1:  ld      a,(de)
        xor     (hl)
        ld      (hl),a
        inc     de
        push    bc
        ld      bc,12
        add     hl,bc
        pop     bc
        djnz    ALOP1

DONE1:

mouse:
 	.db %01000000
 	.db %01100000
 	.db %01110000
	.db %01111000
 	.db %01111100
 	.db %01111000
 	.db %01111100
 	.db %01011000
 #endasm
}

