/*
 * TI-86 Lights out example
 */
#include <ti.h>
#include <line.c>
#include <box.c>
#include <delay.c>

char board[25];
char xpos, ypos;
char moves;
char minmoves;
extern char level;
extern char levels[];

/* Size of the boxs */
#define xsize 13
#define ysize 12

#define setboard(x,y,v) board[(y*5)+x] = v
#define getboard(x,y)   board[(y*5)+x]

main() {
 char inloop, key, cmate, x, z, a;

 /* Earse the contents of the screen */
 indicatoroff;
 clrlcd;

 /* Setup a intro Screen */
 setxy(0,0);
 puts("\n\
     Lights-Out\n\
  A TI-86CC Example\n\
\n\
     By: Chris\n\
    Dannemiller");

 /* Wait for user key press */
 getkey();

 /* Clear screen contents */
  clrlcd;

 /* Earse the boards contents */
 cleanboard();

 /* Setup a trial level */

 /* User is at defualt location */
 xpos = 0;
 ypos = 0;

 /* Display the cool victory dance */
 displaygame();
 vdance();

 /* Display Middle + then wait for user input and then clear it */
 invert(2,2);
 invert(2,1);
 invert(2,3);
 invert(1,2);
 invert(3,2);
 getkey();
 invert(2,2);
 invert(2,1);
 invert(2,3);
 invert(1,2);
 invert(3,2);

 loadlevel();

 moves = 0;
 pushbutton();

 inloop = 1;
 while(inloop == 1)
   {
   key = getkey();
   if(key == kExit || key == kQuit)
     inloop = 0;
   if(key == kUp && ypos > 0)
     {
     relasebutton();
     ypos--;
     pushbutton();
     }
   if(key == kDown && ypos < 4)
     {
     relasebutton();
     ypos++;
     pushbutton();
     }
   if(key == kRight && xpos < 4)
     {
     relasebutton();
     xpos++;
     pushbutton();
     }
   if(key == kLeft && xpos > 0)
     {
     relasebutton();
     xpos--;
     pushbutton();
     }
   if(key == kEnter || key == kAns)
     {
     invert(xpos,ypos);
     invert(xpos+1,ypos);
     invert(xpos-1,ypos);
     invert(xpos,ypos+1);
     invert(xpos,ypos-1);

     if(moves < 100)        /* have to cap moves somwhere don't I */
         moves++;

     /* Check for win */

     cmate=0;

     for(x = 0; x < 25; x++)
       cmate = cmate + board[x];

     if(cmate==0)
       {
       relasebutton();
       moves -= minmoves;
       if(moves > 10)
         {
         for(a=0; a<8; a++)
         {
           /* Display X, I.E. User failed to pass level in minmoves + 10 */
           invert(0,0);
           invert(1,1);
           invert(2,2);
           invert(3,3);
           invert(4,4);
           invert(4,0);
           invert(3,1);
           invert(1,3);
           invert(0,4);
           delay(30);
         }
         /* Reset level info */
         loadlevel();
         }
       else if(moves != 0)
         {
         char ys,xs,p;
         for(a=0; a<8; a++)
           {
           ys = 0;
           xs = 0;
           for(p=0; p<moves; p++)
             {
             invert(xs,ys);
             xs++;
             if(xs > 4) {
               xs = 0;
               ys++;
               }
             }
           delay(30);
           }
         level++;
         loadlevel();
         }
       else          /* Score user beat level in least amount of moves */
         {           /* Possible                                       */
         vdance();
         level++;
         loadlevel();
         }
       }
     }
   }

 /* When quiting reset everything so that the screen looks nice and
  * Pretty
  */
 clrlcd;
 clrscrn;
 setxy(0,0);
 }

loadlevel() {
 char x,y,z,p;
 int ls;
 /* reset game board */
 cleargameboard();

 /* If user has betten final level then give user the final level again */
 if(level == 51)
   level = 50;

 /* Rotine to show n load */
 x = level-1;
 y = 0;

 minmoves = ( ( x ) / 5 ) + 6;

 if(level > 25)
   {
   invert(4,4);
   x -= 25;
   }
 while(x > 4)
   {
   x-=5;
   y++;
   }
 for(z = 0; z < 5; z++)
   {
   if(level != 50)      /* Content needed already displayed */
       invert(x,y);

   delay(50);
   if(level > 25 && level != 50)
    invert(4,4);

   invert(x,y);
   delay(30);
   }

 if(level > 25)
   invert(4,4);

 ls = level*5;
 p = 0;
 while(p < 25)
 {
   board[p]   = (levels[ls] >> 4)    ;
   board[p+1] = (levels[ls] >> 3) & 1;
   board[p+2] = (levels[ls] >> 2) & 1;
   board[p+3] = (levels[ls] >> 1) & 1;
   board[p+4] = (levels[ls]     ) & 1;
   ls++;
   p+=5;
 }

 /* Reset everting about the game logic */
 moves = 0;
 xpos = 0;
 ypos = 0;

 /* RE-DRAW The board */
 drawboard();
 pushbutton();
 }

/* Show the victory Dance or otherwize called the startup rotine */

vdance() {
  int x;
  for(x = 0; x < 5; x++)
    {
    invert(0,x);
    delay(25);
    invert(0,x);
    }
  for(x = 1; x < 5; x++)
    {
    invert(x,4);
    delay(25);
    invert(x,4);
    }
  for(x = 3; x >= 0; x--)
    {
    invert(4,x);
    delay(25);
    invert(4,x);
    }
  for(x = 3; x > 0; x--)
    {
    invert(x,0);
    delay(25);
    invert(x,0);
    }
  for(x = 1; x < 4; x++)
    {
    invert(1,x);
    delay(25);
    invert(1,x);
    }

  invert(2,3);
  delay(25);
  invert(2,3);
  invert(3,3);
  delay(25);
  invert(3,3);
  invert(3,2);
  delay(25);
  invert(3,2);
  invert(3,1);
  delay(25);
  invert(3,1);
  invert(2,1);
  delay(25);
  invert(2,1);
  invert(2,2);
  delay(25);
  invert(2,2);
}

drawboard() {
  char z;
  char x,y;
  for(x = 0; x < 5; x++)
    for(y = 0; y < 5; y++)
      if(getboard(x,y) == 1)
        for(z = y*ysize+4; z < y*ysize+ysize-3; z++)
          line(x*xsize+4,z,x*xsize+xsize-4,z,PT_ON);
  }
  
/* Invert a button and draw proper data on screen */
invert(x,y) char x, y; {
  int z;
  if(x > 4 || x < 0 ||
     y > 4 || y < 0)
    return;
  if(getboard(x,y) == 1)
  {
    setboard(x,y, 0);
    for(z = y*ysize+4; z < y*ysize+ysize-3; z++)
      line(x*xsize+4,z,x*xsize+xsize-4,z,PT_OFF);
  } else {
    setboard(x,y, 1);
    for(z = y*ysize+4; z < y*ysize+ysize-3; z++)
      line(x*xsize+4,z,x*xsize+xsize-4,z,PT_ON);
  }
}

/* Reset game board */
cleanboard() {
  char x;
  for(x = 0; x < 25; x++)
    board[x] = 0;
  }

/* Clean the board and screen */
cleargameboard() {
  char x,y;
  for(x = 0; x < 5; x++)
    for(y = 0; y < 5; y++)
      if(board[y*5+x] == 1)
        invert(x,y);
}

pushbutton() {
  /* Clear old button pushed contents */
  box(xpos*xsize+1, ypos*ysize+1, xpos*xsize+xsize-1, ypos*ysize+ysize-1,PT_OFF);

  /* Display new button push contents */
  line(xpos*xsize+1,ypos*ysize,xpos*xsize+1,ypos*ysize+ysize,PT_ON);
  line(xpos*xsize,ypos*ysize+1,xpos*xsize+xsize,ypos*ysize+1,PT_ON);
  }

relasebutton() {
  /* Clear old button pushed contents */
  box(xpos*xsize+1, ypos*ysize+1, xpos*xsize+xsize-1, ypos*ysize+ysize-1,PT_OFF);

  /* Display new button push contents */
  line(xpos*xsize,ypos*ysize+ysize-1,xpos*xsize+xsize,ypos*ysize+ysize-1,PT_ON);
  line(xpos*xsize+xsize-1,ypos*ysize,xpos*xsize+xsize-1,ypos*ysize+ysize,PT_ON);
  }

displaygameboard()
 {
 /* Draw all 3d boxs */
 char x, y, z;

 for(x = 0; x < 5; x++)
   for(y = 0; y < 5; y++)
     {
     box(x*xsize,y*ysize,x*xsize+xsize,y*ysize+ysize,PT_ON);
     box(x*xsize+2,y*ysize+2,x*xsize+xsize-2,y*ysize+ysize-2,PT_ON);
     line(x*xsize,y*ysize+ysize-1,x*xsize+xsize,y*ysize+ysize-1,PT_ON);
     line(x*xsize+xsize-1,y*ysize,x*xsize+xsize-1,y*ysize+ysize,PT_ON);
     }
 }

#asm
levels:
; Bytes is 5 * 52 = 260
; Blank level for header
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
; Level 1
  .db   00000000b
  .db   00000000b
  .db   00010101b
  .db   00000000b
  .db   00000000b
; Level 2
  .db   00010101b
  .db   00010101b
  .db   00000000b
  .db   00010101b
  .db   00010101b
; Level 3
  .db   00001010b
  .db   00011011b
  .db   00011011b
  .db   00011011b
  .db   00001010b
; Level 4
  .db   00000000b
  .db   00011011b
  .db   00000000b
  .db   00010001b
  .db   00011011b
; Level 5
  .db   00011110b
  .db   00011101b
  .db   00011101b
  .db   00000011b
  .db   00011011b
; Level 6
  .db   00000000b
  .db   00000000b
  .db   00010101b
  .db   00010101b
  .db   00001110b
; Level 7
  .db   00011110b
  .db   00010001b
  .db   00010001b
  .db   00010001b
  .db   00011110b
; Level 8
  .db   00000000b
  .db   00000100b
  .db   00001010b
  .db   00010101b
  .db   00001010b
; Level 9
  .db   00001010b
  .db   00011111b
  .db   00001110b
  .db   00001011b
  .db   00011100b
; Level 10
  .db   00001110b
  .db   00001110b
  .db   00001110b
  .db   00000000b
  .db   00000000b
; Level 11
  .db   00010101b
  .db   00010101b
  .db   00010101b
  .db   00010101b
  .db   00001110b
; Level 12
  .db   00011111b
  .db   00001010b
  .db   00011011b
  .db   00001110b
  .db   00001010b
; Level 13
  .db   00000010b
  .db   00000101b
  .db   00001010b
  .db   00010100b
  .db   00001000b
; Level 14
  .db   00000000b
  .db   00000000b
  .db   00001000b
  .db   00001000b
  .db   00001000b
; Level 15
  .db   00000000b
  .db   00001000b
  .db   00000000b
  .db   00001000b
  .db   00000000b
; Level 16
  .db   00010000b
  .db   00010000b
  .db   00010000b
  .db   00010000b
  .db   00011111b
; Level 17
  .db   00000000b
  .db   00000000b
  .db   00000100b
  .db   00001110b
  .db   00011111b
; Level 18
  .db   00000100b
  .db   00001010b
  .db   00010101b
  .db   00001010b
  .db   00000100b
; Level 19
  .db   00010101b
  .db   00000000b
  .db   00010101b
  .db   00000000b
  .db   00010101b
; Level 20
  .db   00000000b
  .db   00000000b
  .db   00010001b
  .db   00000000b
  .db   00000000b
; Level 21
  .db   00001111b
  .db   00001000b
  .db   00001110b
  .db   00001000b
  .db   00001000b
; Level 22
  .db   00001110b
  .db   00010001b
  .db   00010001b
  .db   00010001b
  .db   00001110b
; Level 23
  .db   00000000b
  .db   00000000b
  .db   00000111b
  .db   00000110b
  .db   00000100b
; Level 24
  .db   00000000b
  .db   00000000b
  .db   00010001b
  .db   00011111b
  .db   00001001b
; Level 25
  .db   00010000b
  .db   00011000b
  .db   00011100b
  .db   00011110b
  .db   00001111b
; Level 26
  .db   00010001b
  .db   00010001b
  .db   00011111b
  .db   00010001b
  .db   00010001b
; Level 27
  .db   00000100b
  .db   00001110b
  .db   00000100b
  .db   00000100b
  .db   00000100b
; Level 28
  .db   00000000b
  .db   00000000b
  .db   00000111b
  .db   00000111b
  .db   00000111b
; Level 29
  .db   00000000b
  .db   00001000b
  .db   00000000b
  .db   00000000b
  .db   00000000b
; Level 30
  .db   00000000b
  .db   00000000b
  .db   00000100b
  .db   00000000b
  .db   00000000b
; Level 31
  .db   00010001b
  .db   00011001b
  .db   00010101b
  .db   00010011b
  .db   00010001b
; Level 32
  .db   00011111b
  .db   00000010b
  .db   00000100b
  .db   00001000b
  .db   00011111b
; Level 33
  .db   00000010b
  .db   00000010b
  .db   00010101b
  .db   00010001b
  .db   00010011b
; Level 34
  .db   00000101b
  .db   00010001b
  .db   00010001b
  .db   00001101b
  .db   00001111b
; Level 35
  .db   00000011b
  .db   00001010b
  .db   00010001b
  .db   00010101b
  .db   00000000b
; Level 36
  .db   00000100b
  .db   00001010b
  .db   00010001b
  .db   00011111b
  .db   00010001b
; Level 37
  .db   00000000b
  .db   00001110b
  .db   00001110b
  .db   00001110b
  .db   00000000b
; Level 38
  .db   00010101b
  .db   00001010b
  .db   00010101b
  .db   00001010b
  .db   00010101b
; Level 39
  .db   00001010b
  .db   00010000b
  .db   00011000b
  .db   00000110b
  .db   00001010b
; Level 40
  .db   00000000b
  .db   00000000b
  .db   00001010b
  .db   00000000b
  .db   00000000b
; Level 41
  .db   00010001b
  .db   00001010b
  .db   00000100b
  .db   00000100b
  .db   00000100b
; Level 42
  .db   00011100b
  .db   00010010b
  .db   00011100b
  .db   00010010b
  .db   00011100b
; Level 43
  .db   00010001b
  .db   00011010b
  .db   00011100b
  .db   00001000b
  .db   00001110b
; Level 44
  .db   00000000b
  .db   00011011b
  .db   00011111b
  .db   00000100b
  .db   00001110b
; Level 45
  .db   00001110b
  .db   00010100b
  .db   00000111b
  .db   00011110b
  .db   00010101b
; Level 46
  .db   00000100b
  .db   00001110b
  .db   00011111b
  .db   00001110b
  .db   00000100b
; Level 47
  .db   00000100b
  .db   00011111b
  .db   00010100b
  .db   00001001b
  .db   00000001b
; Level 48
  .db   00000000b
  .db   00010001b
  .db   00000100b
  .db   00010001b
  .db   00000000b
; Level 49
  .db   00010001b
  .db   00001010b
  .db   00000100b
  .db   00001010b
  .db   00010001b
; Level 50
  .db   00011111b
  .db   00011111b
  .db   00011111b
  .db   00011111b
  .db   00011111b
; Current Level
level:
  .db   $01
#endasm
